define(function() {
	return function(/* ..., obj */) {
		// Prototype.
		var obj = arguments[arguments.length-1];

		// Constructor.
		if (!obj.hasOwnProperty('constructor')) {
			obj.constructor = function UnnamedClass() { };
		}
		obj.constructor.prototype = obj;

		// Inheritance.
		for (var i=0;i<arguments.length-1;i++) {
			var o = arguments[i];
			for(var name in o.prototype) {
				if (o.prototype.hasOwnProperty(name)) {
					if (!obj.hasOwnProperty(name)) {
						obj[name] = o.prototype[name];
					}
				}
			}
		}
		return obj.constructor;
	};
});
