define(['class','underscore'],function(Class,_) {
	function on(name, fun) {
		var l = this.events[name];
		if (!l) { l = this.events[name] = []; }
		l.push(fun);
		return this;
	}
	function once(name, fun) {
		this.on(name, function wrapper(arg) {
			removeListener(name, wrapper);
			fun(arg);
		});
		return this;
	}
	function removeListener(name, fun) {
		var l = this.events[name];
		if (l) {
			l.remove(fun);
		}
		return this;
	}
	function emit(/* name, ... */) {
		var name = _.first(arguments);
		var callbackArguments = _.rest(arguments);
		var l = this.events[name];
		if (l) {
			l.forEach(function(f) {
				f.apply(undefined, callbackArguments);
			});
		}
		return this;
	}
	return Class({
		events: {},
		on: on,
		once: once,
		removeListener: removeListener,
		emit: emit
	});
});
