define(['class','linesegment'],function(Class,LineSegment) {
	var Room = Class({
		constructor: function(opts) {
			function e(n){return opts[n]||null;}
			this.exits = {N:e('N'),E:e('E'),S:e('S'),W:e('W')};
			this.lineSegments = opts.l || opts.lineSegments || Room.Outline();
			this.objects = opts.o || opts.objects || [];
		},
		draw: function(ctx) {
			ctx.beginPath();
			for(var i=0;i<this.lineSegments.length;i++) {
				var s = this.lineSegments[i].start;
				var e = this.lineSegments[i].end;
				ctx.moveTo(s.x,s.y);
				ctx.lineTo(e.x,e.y);
			}
			ctx.stroke();
		}
	});
	Room.size = 640;
	Room.doorSize = 80;
	Room.Outline = function() {
		var r = Room.size-80;
		var t = 80;
		var d = Room.doorSize;
		var rh = r/2;
		var dh = d/2;
		return Room.Polygon([
			0,	0,

			0,	rh-dh,
			0-t,rh-dh,
			0-t,rh+dh,
			0,	rh+dh,

			0,	r,

			rh-dh,	r,
			rh-dh,	r+t,
			rh+dh,	r+t,
			rh+dh,	r,

			r,	r,

			r,	rh+dh,
			r+t,rh+dh,
			r+t,rh-dh,
			r,	rh-dh,

			r,	0,

			rh+dh,	0,
			rh+dh,	0-t,
			rh-dh,	0-t,
			rh-dh,	0
			].map(function(v,i) { return v+t/2; }));
	};
	Room.Polygon = function(ps) {
		var r = [];
		for(var i=0;i<ps.length;i+=2) {
			r.push(new LineSegment(ps[i+0], ps[i+1], ps[(i+2)%ps.length], ps[(i+3)%ps.length]));
		}
		return r;
	};
	Room.Rectangle = function(x,y,w,h) {
		return Room.Polygon([
			x,y,
			x+w,y,
			x+w,y+h,
			x,y+h
		]);
	};
	return Room;
});
